<template>
  <v-card class="mx-auto" max-width="100%">
    <confirmation-modal :is-open="openModal" :modal-text="modalText" @confirm="confirmRegister" @cancel="cancelRegister" />
    <v-card-subtitle class="pb-0">
      <image-field v-model="specialist.user.image" :disabled="disabled_user_info" :validation="imageValidation" />
      <v-divider />
      <v-form ref="form" lazy-validation>
        <v-container fluid>
          <select-field v-model="typeDocumentSelected" :items="typesDocument" field-name="Tipo de documento" @selectChange="changeSELECT" />
          <register-field-validation
            v-if="typeDocumentSelected==='DNI'"
            v-model="specialist.user.document"
            field-name="DNI"
            :validation="DNIValidation"
            place-holder="Ingrese DNI"
            @inputChange="changeDNI"
          />
          <register-field-validation
            v-if="typeDocumentSelected==='CARNET EXTRANJERÍA'"
            v-model="specialist.user.document"
            field-name="Carnet de extranjería"
            :validation="carnetValidation"
            place-holder="Ingrese carnet de extranjería"
            @inputChange="changeCarnetOrPassport"
          />
          <register-field-validation
            v-if="typeDocumentSelected==='PASAPORTE'"
            v-model="specialist.user.document"
            field-name="Pasaporte"
            :validation="passportValidation"
            place-holder="Ingrese pasaporte"
            @inputChange="changeCarnetOrPassport"
          />
          <register-field-validation v-model="specialist.user.name" :disabled="disabled_user_info || typeDocumentSelected=='DNI'" field-name="Nombre" :validation="nameValidation" place-holder="Ingrese nombre" />
          <register-field-validation v-model="specialist.user.fatherLastname" :disabled="disabled_user_info || typeDocumentSelected=='DNI'" field-name="Apellido Paterno" :validation="fatherLastnameValidation" place-holder="Ingrese apellido paterno" />
          <register-field-validation v-model="specialist.user.motherLastname" :disabled="disabled_user_info || typeDocumentSelected=='DNI'" field-name="Apellido Materno " :validation="motherLastNameValidation" place-holder="Ingrese apellido materno" />
          <email-field v-model="specialist.user.email" :disabled="disabled_user_info" field-name="Correo" :validation="emailValidation" />
          <register-field-validation
            v-model="specialist.phoneNumber"
            :disabled="disabled_user_info"
            field-name="Celular"
            :validation="phoneValidation"
            place-holder="Ingrese número celular"
            :obligatory="false"
          />
          <directions-field
            v-model="specialist.user.address"
            :disabled="disabled_user_info"
            field-name="Domicilio"
            place-holder="Ingrese domicilio"
            :obligatory="false"
            @changeAddress="updateDirection"
          />
          <picker-field v-model="specialist.user.birthdate" :disabled="disabled_user_info" field-name="Fecha de Nacimiento" :max="$config.birthdateValidation" :validation="birthDateValidation" />
          <register-field-validation v-model="specialist.specialty" :disabled="disabled_specialist_info" field-name="Especialidad" place-holder="Ingrese especialidad" />
        </v-container>
      </v-form>
    </v-card-subtitle>
    <buttons-register-form :disabled="disabled_specialist_info" @saveUser="handleRegisterSpecialist()" @cancel="cancelForm" />
    <br>
    <v-snackbar v-model="snackBar.show" :color="snackBar.color" text top>
      {{ snackBar.text }}
      <template #action="{ attrs }">
        <v-btn color="blue" text v-bind="attrs" @click="snackBar.show = false">
          <v-icon>mdi-window-close</v-icon>
        </v-btn>
      </template>
    </v-snackbar>
  </v-card>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import {
  DNIRules,
  nameRules,
  fatherLastnameRules,
  motherLastnameRules,
  emailRules,
  imageFileRules,
  phoneRules,
  carnetRules,
  passportRules,
  birthDateRules,
} from '@/helpers/validation';
import RegisterFieldValidation from '~/components/InputField/RegisterFieldValidation';
import PickerField from '~/components/InputField/PickerField';
import SelectField from '~/components/InputField/SelectField.vue';
import ButtonsRegisterForm from '~/components/InputField/ButtonsRegisterForm.vue';
import imageField from '~/components/InputField/ImageField';
import ConfirmationModal from '~/components/register/confirmationModal';
import DirectionsField from '~/components/InputField/DirectionsField';
import EmailField from '~/components/InputField/EmailField';
export default {
  name: 'RegisterSpecialist',
  components: { RegisterFieldValidation, PickerField, ButtonsRegisterForm, imageField, ConfirmationModal, SelectField, DirectionsField, EmailField },
  data: () => ({
    typeDocumentSelected: 'DNI',
    typesDocument: ['CARNET EXTRANJERÍA', 'DNI', 'PASAPORTE'],
    disabled_user_info: true,
    disabled_specialist_info: true,
    isValidForm: false,
    DNIValidation: DNIRules,
    carnetValidation: carnetRules,
    passportValidation: passportRules,
    nameValidation: nameRules,
    fatherLastnameValidation: fatherLastnameRules,
    motherLastNameValidation: motherLastnameRules,
    emailValidation: emailRules,
    imageValidation: imageFileRules,
    phoneValidation: phoneRules,
    birthDateValidation: birthDateRules,
    openModal: false,
    modalText: '¿Estás seguro que deseas registrar a este especialista?',
    snackBar: {
      show: false,
      color: '',
      text: '',
    },
    specialist: {
      user: {
        image: null,
        document: '',
        typeDocument: '',
        name: '',
        fatherLastname: '',
        motherLastname: '',
        email: '',
        phoneNumber: '',
        address: '',
        birthdate: new Date('2000-01-01').toISOString().substr(0, 10),
      },
      specialty: '',
    },
  }),

  computed: {
    ...mapState({
      checkedSpecialist: state => state.specialists.checkedSpecialist,
    }),
  },

  methods: {
    ...mapActions({
      saveSpecialist: 'specialists/saveSpecialist',
      checkedInformationSpecialist: 'specialists/checkedInformationSpecialist',
    }),
    async confirmRegister() {
      await this.register(this.specialist);
      await this.$router.push('/especialistas');
    },

    cancelRegister() {
      this.openModal = false;
    },
    updateDirection(newAddress) {
      this.specialist.user.address = newAddress.route;
    },
    handleRegisterSpecialist() {
      if (this.$refs.form.validate() && !this.disabled_specialist_info) {
        this.specialist.user.typeDocument = this.typeDocumentSelected;
        this.openModal = true;
      } else {
        this.setNackBar('Complete los campos obligatorios', 'error', true);
      }
    },
    async register(specialist) {
      console.log(specialist);
      await this.saveSpecialist(specialist);
    },
    cancelForm() {
      // this.$refs.form.reset();
      this.$router.push('/especialistas');
    },
    changeSELECT() {
      this.specialist.user.document = '';
      this.clearForm();
    },
    async changeDNI(valid) {
      this.valid = valid;
      if (valid) {
        const checkedSpecialist = await this.checkedInformationSpecialist(this.specialist.user.document);
        this.checkedUser(checkedSpecialist.data, this.typeDocumentSelected);
      } else {
        this.disabled_user_info = true;
        this.disabled_specialist_info = true;
      }
    },
    async changeCarnetOrPassport(valid) {
      this.valid = valid;
      if (valid) {
        this.disabled_specialist_info = false;
        const checkedSpecialist = await this.checkedInformationSpecialist(this.specialist.user.document);
        this.checkedUserWithCarnetOrPassport(checkedSpecialist.data, this.typeDocumentSelected);
      } else {
        this.disabled_user_info = true;
        this.disabled_specialist_info = true;
      }
    },
    checkedUser(specialist, typeDocumentSelected) {
      this.clearForm();
      this.disabled_user_info = true;
      this.disabled_specialist_info = true;

      /* If a user with this DNI doesn't exist */
      if (specialist.user == null && specialist.userApi == null) {
        this.setNackBar(typeDocumentSelected + ' INCORRECTO', 'error', true);
      }
      /* If a user found with API but doesn't register in BD (this user is NOT a specialist) */
      if (this.valid && specialist.userApi != null) {
        this.setNackBar(typeDocumentSelected + ' valido, complete los demás campos', 'primary', true);
        this.completeNamesLastNames(specialist.userApi.nombres, specialist.userApi.apellidoPaterno, specialist.userApi.apellidoMaterno);
      }

      /* If a user with this DNI exist AND this user is a specialist */
      if (this.valid && specialist.user != null) {
        if (specialist.isSpecialist) {
          this.ifUserRegisteredIsSpecialist(specialist, typeDocumentSelected);
        } else {
          this.setNackBar(typeDocumentSelected + ' valido, complete los demás campos', 'primary', true);
          this.completeNamesLastNames(specialist.user.name, specialist.user.fatherLastname, specialist.user.motherLastname);
        }
      }
    },
    completeNamesLastNames(name, fatherLastname, motherLastname) {
      this.specialist.user.name = name;
      this.specialist.user.fatherLastname = fatherLastname;
      this.specialist.user.motherLastname = motherLastname;
      this.disabled_user_info = false;
      this.disabled_specialist_info = false;
    },
    checkedUserWithCarnetOrPassport(specialist, typeDocumentSelected) {
      this.clearForm();
      this.disabled_user_info = true;
      this.disabled_specialist_info = true;

      /* If a user with this DOCUMENT is not registered in BD OR This user is NOT a specialist */
      if (this.valid && specialist.user == null) {
        this.setNackBar(typeDocumentSelected + ' valido, complete los demás campos', 'primary', true);
        this.disabled_user_info = false;
        this.disabled_specialist_info = false;
      }

      /* If a user with this DOCUMENT exist AND this user is a specialist */
      if (this.valid && specialist.user != null && specialist.isSpecialist) {
        this.ifUserRegisteredIsSpecialist(specialist, typeDocumentSelected);
      }
    },
    ifUserRegisteredIsSpecialist(specialist, typeDocumentSelected) {
      this.setNackBar('Especialista registrado con el ' + typeDocumentSelected + ' ingresado', 'error', true);
      this.specialist.user = specialist.user;
    },
    setNackBar(text, color, show) {
      this.snackBar.text = text;
      this.snackBar.show = show;
      this.snackBar.color = color;
    },
    clearForm() {
      this.specialist.user.name = '';
      this.specialist.user.fatherLastname = '';
      this.specialist.user.motherLastname = '';
      this.specialist.user.email = '';
      this.specialist.user.phoneNumber = '';
      this.specialist.user.address = '';
      this.specialist.user.birthdate = '';
      this.specialist.specialty = '';
    },
  },
};
</script>
